%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Name:      Xueyan Li
%Filename:  bwmorphor.m  (Iterative Morph Operations)
%CIS581 Final Project
%Instructor:    Longin Jan Lateckie
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Read image
fordInput = imread( 'ford.tiff' );
sonyInput = imread( 'sony.tiff' );

% converting to binary image
fordIn = im2bw( fordInput );
sonyIn = im2bw( sonyInput );

%create structuring elements
% 11-by-11 square
se1 = strel( 'square', 11 );  

%%%%%%%%%%%%%% Dilation 
figure( 'Name', 'bwmorph() dilation Test' );

%perform dilation
fordOut = bwmorph( fordIn, 'dilate', 1 );

%save as a new TIFF file
imwrite( fordOut, 'dilate-1-ford.tiff' );

%Display result
subplot(4,2,1), imshow(fordIn), title('Original Ford');
subplot(4,2,2), imshow(sonyIn), title('Original Sony');

subplot(4,2,3), imshow(fordOut), title('bwmorph() Dilation N=1');

fordOut = bwmorph( fordIn, 'dilate', 5 );
imwrite( fordOut, 'dilate-5-ford.tiff' );
subplot(4,2,5), imshow(fordOut), title('bwmorph() Dilation N=5');

fordOut = bwmorph( fordIn, 'dilate', Inf );
imwrite( fordOut, 'dilate-inf-ford.tiff' );
subplot(4,2,7), imshow(fordOut), title('bwmorph() Dilation N=Inf');

sonyOut = bwmorph( sonyIn, 'dilate', 1 );
imwrite( sonyOut, 'dilate-1-sony.tiff' );
subplot(4,2,4), imshow(sonyOut), title('bwmorph() Dilation N=1');

sonyOut = bwmorph( sonyIn, 'dilate', 5 );
imwrite( sonyOut, 'dilate-5-sony.tiff' );
subplot(4,2,6), imshow(sonyOut), title('bwmorph() Dilation N=5');

sonyOut = bwmorph( sonyIn, 'dilate', Inf );
imwrite( sonyOut, 'dilate-inf-sony.tiff' );
subplot(4,2,8), imshow(fordOut), title('bwmorph() Dilation N=Inf');

%%%%%%%%%%%%%% Erosion
figure( 'Name', 'bwmorph() Erosion Test' );
subplot(4,2,1), imshow(fordIn), title('Original Ford');
subplot(4,2,2), imshow(sonyIn), title('Original Sony');

fordOut = bwmorph( fordIn, 'erode', 1 );
imwrite( fordOut, 'erode-1-ford.tiff' );
subplot(4,2,3), imshow(fordOut), title('bwmorph() Erosion N=1');

fordOut = bwmorph( fordIn, 'erode', 5 );
imwrite( fordOut, 'erode-5-ford.tiff' );
subplot(4,2,5), imshow(fordOut), title('bwmorph() Erosion N=5');

fordOut = bwmorph( fordIn, 'erode', Inf );
imwrite( fordOut, 'erode-inf-ford.tiff' );
subplot(4,2,7), imshow(fordOut), title('bwmorph() Erosion N=Inf');

sonyOut = bwmorph( sonyIn, 'erode', 1 );
imwrite( sonyOut, 'erode-1-sony.tiff' );
subplot(4,2,4), imshow(sonyOut), title('bwmorph() Erosion N=1');

sonyOut = bwmorph( sonyIn, 'erode', 5 );
imwrite( sonyOut, 'erode-5-sony.tiff' );
subplot(4,2,6), imshow(sonyOut), title('bwmorph() Erosion N=5');

sonyOut = bwmorph( sonyIn, 'erode', Inf );
imwrite( sonyOut, 'erode-inf-sony.tiff' );
subplot(4,2,8), imshow(sonyOut), title('bwmorph() Erosion N=Inf');

%%%%%%%%%% Open
figure( 'Name', 'bwmorph() Open Test' );
subplot(4,2,1), imshow(fordIn), title('Original Ford');
subplot(4,2,2), imshow(sonyIn), title('Original Sony');

fordOut = bwmorph( fordIn, 'open', 1 );
imwrite( fordOut, 'open-1-ford.tiff' );
subplot(4,2,3), imshow(fordOut), title('bwmorph() Open N=1');

fordOut = bwmorph( fordIn, 'open', 5 );
imwrite( fordOut, 'open-5-ford.tiff' );
subplot(4,2,5), imshow(fordOut), title('bwmorph() Open N=5');

fordOut = bwmorph( fordIn, 'open', Inf );
imwrite( fordOut, 'open-inf-ford.tiff' );
subplot(4,2,7), imshow(fordOut), title('bwmorph() Open N=Inf');

sonyOut = bwmorph( sonyIn, 'open', 1 );
imwrite( sonyOut, 'open-1-sony.tiff' );
subplot(4,2,4), imshow(sonyOut), title('bwmorph() Open N=1');

sonyOut = bwmorph( sonyIn, 'open', 5 );
imwrite( sonyOut, 'open-5-sony.tiff' );
subplot(4,2,6), imshow(sonyOut), title('bwmorph() Open N=5');

sonyOut = bwmorph( sonyIn, 'open', Inf );
imwrite( sonyOut, 'open-inf-sony.tiff' );
subplot(4,2,8), imshow(sonyOut), title('bwmorph() Open N=Inf');

%%%%%%%%%%%Close
figure( 'Name', 'bwmorph() Close Test' );
subplot(4,2,1), imshow(fordIn), title('Original Ford');
subplot(4,2,2), imshow(sonyIn), title('Original Sony');

fordOut = bwmorph( fordIn, 'close', 1 );
imwrite( fordOut, 'close-1-ford.tiff' );
subplot(4,2,3), imshow(fordOut), title('bwmorph() Close N=1');

fordOut = bwmorph( fordIn, 'close', 5 );
imwrite( fordOut, 'close-5-ford.tiff' );
subplot(4,2,5), imshow(fordOut), title('bwmorph() Close N=5');

fordOut = bwmorph( fordIn, 'close', Inf );
imwrite( fordOut, 'close-inf-ford.tiff' );
subplot(4,2,7), imshow(fordOut), title('bwmorph() Close N=Inf');

sonyOut = bwmorph( sonyIn, 'close', 1 );
imwrite( sonyOut, 'close-1-sony.tiff' );
subplot(4,2,4), imshow(sonyOut), title('bwmorph() Close N=1');

sonyOut = bwmorph( sonyIn, 'close', 5 );
imwrite( sonyOut, 'close-5-sony.tiff' );
subplot(4,2,6), imshow(sonyOut), title('bwmorph() Close N=5');

sonyOut = bwmorph( sonyIn, 'close', Inf );
imwrite( sonyOut, 'close-inf-sony.tiff' );
subplot(4,2,8), imshow(sonyOut), title('bwmorph() Close N=Inf');

