%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Name:      Xueyan Li
%Filename:  morphor.m
%CIS581 Final Project
%Instructor:    Longin Jan Lateckie
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Read image
fordIn = imread( 'ford.tiff' );
sonyIn = imread( 'sony.tiff' );

%create structuring elements
% 11-by-11 square
se1 = strel( 'square', 11 );  

figure( 'Name', 'Ford Logo Test' );

%perform dilation
fordOut = imdilate( fordIn, se1 );

%save as a new TIFF file
imwrite( fordOut, 'imdilate-ford.tiff' );

%Display result
subplot(3,2,1), imshow(fordIn), title('Original');
subplot(3,2,3), imshow(fordOut), title('Dilation');

fordOut = imerode( fordIn, se1 );
imwrite( fordOut, 'imerode-ford.tiff' );
subplot(3,2,4), imshow(fordOut), title('Erosion');

fordOut = imopen( fordIn, se1 );
imwrite( fordOut, 'imopen-ford.tiff' );
subplot(3,2,5), imshow(fordOut), title('Open');

fordOut = imclose( fordIn, se1 );
imwrite( fordOut, 'imclose-ford.tiff' );
subplot(3,2,6), imshow(fordOut), title('Close');

figure( 'Name', 'SONY Logo Test' );
%perform dilation
sonyOut = imdilate( sonyIn, se1 );

%save as a new TIFF file
imwrite( sonyOut, 'imdilate-sony.tiff' );

%Display result
subplot(3,2,1), imshow(sonyIn), title('Original');
subplot(3,2,3), imshow(sonyOut), title('Dilation');

sonyOut = imerode( sonyIn, se1 );
imwrite( sonyOut, 'imerode-sony.tiff' );
subplot(3,2,4), imshow(sonyOut), title('Erosion');

sonyOut = imopen( sonyIn, se1 );
imwrite( sonyOut, 'imopen-sony.tiff' );
subplot(3,2,5), imshow(sonyOut), title('Open');

sonyOut = imclose( sonyIn, se1 );
imwrite( sonyOut, 'imclose-sony.tiff' );
subplot(3,2,6), imshow(sonyOut), title('Close');

